#include <curl/curl.h>

typedef struct MemoryStructResult {
  unsigned char   *effective_url;
  unsigned char   *memory;
  unsigned char   *error;
  unsigned char   *mime_type;
  unsigned long   http_code;
  unsigned short  curl_error_code;
  size_t size;
} result_t;

CURL * init(result_t *);
void cleanup(CURL*);

result_t * createMemoryStruct(void);
size_t WriteMemoryCallbackStruct(void *, size_t, size_t, void *);


long getHTTPCode(result_t *);
unsigned char* getBody(result_t *);
unsigned char* getEffectiveUrl(result_t *);
unsigned char* getMimeType(result_t *);
int getBodySize(result_t *);

void cleanup_memory(result_t *);
void cleanup_chunk(result_t *);
void setError(result_t *, int, unsigned char *);

